/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id$
 */

/*
 *        RAˑW[iARMpj
 */
#include "kernel_impl.h"
#include "check.h"
#include "task.h"

/*
 *  ReLXgQƂ̂߂̕ϐ
 */
uint32_t excpt_nest_count;

#ifndef VECTOR_KERNEL
/*
 *  OxN^ɏ܂ꂽWv߂QƂAhX
 * 
 */
uint32_t *arm_vector_ref_tbl_add[8];

/*
 * Oɉnh̋NԒn
 */
uint32_t arm_saved_exch_add[8];
#endif /* VECTOR_KERNEL */

/*
 *  vZbTˑ̏
 */
void
core_initialize()
{
    /*
     *  J[lN͔^XNReLXgƂē삳邽1
     */ 
    excpt_nest_count = 1;
    
#ifndef VECTOR_KERNEL    
    {
        uint32_t i, vector_value;

        /*
         * OxN^ɓo^Ă閽߂QƂAhXƁC
         * ̃AhX̓e(nh̔Ԓn)ۑD
         */
        for(i = 0; i < TNUM_EXCH; i++){
            vector_value = *(volatile uint32_t *)(VECTOR_START + (i*4));
            vector_value &= 0x00000fff;
            arm_vector_ref_tbl_add[i]  =  (uint32_t *)(vector_value + 8) + i;
            arm_saved_exch_add[i] = *(arm_vector_ref_tbl_add[i]);
        }
    }
#endif /* VECTOR_KERNEL */    
}

/*
 *  vZbTˑ̏I
 */
void
core_terminate(void)
{
#ifndef VECTOR_KERNEL
    uint32_t i;
    
    /*
     * OxN^ɖ߂
     */
    for(i = 0; i < TNUM_EXCH; i++){
        *arm_vector_ref_tbl_add[i]  = arm_saved_exch_add[i];
    }    
#endif /* VECTOR_KERNEL */   
}

/*
 *  CPUO̔󋵂̃Oo
 *
 *  CPUOnh̒CCPUO|C^ip_excinfjƂ
 *  ČĂяoƂŁCCPUO̔󋵂VXeOɏo͂D
 */
#ifdef SUPPORT_XLOG_SYS

void
xlog_sys(void *p_excinf)
{    
}

#endif /* SUPPORT_XLOG_SYS */

/*
 *  OxN^璼ڎsnho^
 */ 
void
x_install_exc(EXCNO excno, FP exchdr)
{
#ifdef VECTOR_KERNEL
    *(((FP*)vector_ref_tbl) + excno) = exchdr;
#else
    *arm_vector_ref_tbl_add[excno] = (uint32_t)exchdr;
#endif /* VECTOR_KERNEL */    
}

#ifndef OMIT_DEFAULT_EXC_HANDLER
/*
 * `̗Oꍇ̏
 */
void
default_exc_handler(void){
    syslog_0(LOG_EMERG, "Unregistered Exception occurs.");
	while(1); /* TEST */
    ext_ker();
}
#endif /* OMIT_DEFAULT_EXC_HANDLER */
