/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id$
 */


/*
 *      RAˑW[iARMpj
 *
 *  ̃CN[ht@ĆCtarget_config.hi܂́CCN
 *  [ht@Cĵ݂CN[hD̃t@C
 *  ڃCN[hĂ͂ȂȂD
 */

#ifndef TOPPERS_CORE_CONFIG_H
#define TOPPERS_CORE_CONFIG_H

/*
 *  ARMˑ̒`
 */
#include "arm.h"

/*
 *  CPUbNƂCPSR̃p^[
 */
#ifndef CPSR_CPULOCK
#define CPSR_CPULOCK     (CPSR_IRQ_BIT)
#endif  /* CPSR_CPULOCK */

/*
 *  ݃bNƂCPSR̃p^[
 */
#define CPSR_INTLOCK     (CPSR_FIQ_BIT|CPSR_IRQ_BIT)

/*
 *  CPSRɏɃZbgp^[
 */
#ifndef CPSR_ALWAYS_SET
#define CPSR_ALWAYS_SET  0x00
#endif  /* CPSR_ALWAYS_SET */

/*
 *  O̔ԍ
 */
#define EXCH_NO_RESET     0
#define EXCH_NO_UNDEF     1
#define EXCH_NO_SWI       2
#define EXCH_NO_PABORT    3
#define EXCH_NO_DABORT    4
#define EXCH_NO_IRQ       5
#define EXCH_NO_FIQ       6

/*
 *  Ǒ
 */  
#define TNUM_EXCH         7

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ^XNReLXgp̃X^bNl
 */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char_t *)(istk) + (istksz)))

/*
 *  vZbT̓ꖽ߂̃CC֐`
 */
#include "core_insn.h"

/*
 *  ^XNReLXgubN̒`
 */
typedef struct task_context_block {
    void  *sp;       /* X^bN|C^ */
    FP    pc;        /* vOJE^ */
} CTXB;


/*
 *  TOPPERSWݏf̎
 *
 *  IRQJ[lǗCFIQJ[lǗO݂̊ƂĈD
 * 
 *  ARMˑł́CTOPPERSWݏf̂CCPUbN
 *  ݂̂舵DݗDx}XNCݗv֎~tOɊւ
 *  ́Ce^[QbgˑŎ舵
 */

/*
 *  ReLXgQƂ̂߂̕ϐ
 */
extern uint32_t excpt_nest_count; /* Oi/CPUOj̃lXg񐔂̃JEg */

/*
 *  ReLXg̎Q
 *
 *  ARMł́C^XNReLXgƔ^XNReLXg̗X[p[
 *  oCU[[hœ삳D̂߁CCPSR̓eł͔ʂłȂD
 *  ̂߁COi/CPUOj̃lXg񐔂JEgϐ
 *  iexcpt_nest_countjpӂCO̓ŃCNg邱
 *  ŁCReLXg𔻒肷D
 */
Inline bool_t
sense_context(void)
{
    return(excpt_nest_count > 0U);
}

/*
 *  CPUbNԂւ̈ڍs
 */
Inline void
x_lock_cpu(void)
{
    set_sr(current_sr() | CPSR_CPULOCK | CPSR_ALWAYS_SET);
    /* NeBJZNV̑OŃ\ */
    Asm("":::"memory");
}

#define t_lock_cpu()   x_lock_cpu()
#define i_lock_cpu()   x_lock_cpu()

/*
 *  CPUbNԂ̉
 */
Inline void
x_unlock_cpu(void)
{
    /* NeBJZNV̑OŃ\ */
    Asm("":::"memory");
    set_sr((current_sr() & (~CPSR_CPULOCK)) | CPSR_ALWAYS_SET);
}

#define t_unlock_cpu() x_unlock_cpu()
#define i_unlock_cpu() x_unlock_cpu()

/*
 *  CPUbNԂ̎Q
 */
Inline bool_t
x_sense_lock(void)
{
    return((current_sr() & CPSR_CPULOCK) == CPSR_CPULOCK);    
}

#define t_sense_lock()    x_sense_lock()
#define i_sense_lock()    x_sense_lock()

/*
 *  ^XNfBXpb`
 */

/*
 *  ōD揇ʃ^XNւ̃fBXpb`icore_support.Sj
 *
 *  dispatch́C^XNReLXgĂяoꂽT[rXR[
 *  ĂяôׂŁC^XNReLXgECPUbNԁEfBXpb
 *  `ԁEif́jݗDx}XNSԂŌĂяo
 *  ΂ȂȂD
 */
extern void dispatch(void);

/*
 *  fBXpb`̓Jnicore_support.Sj
 *
 *  start_dispatch́CJ[lNɌĂяôׂŁCׂĂ̊
 *  ݂֎~ԁi݃bNԂƓ̏ԁjŌĂяoȂ
 *  ȂȂD
 */
extern void start_dispatch(void) NoReturn;

/*
 *  ݂̃ReLXĝĂăfBXpb`icore_support.Sj
 *
 *  exit_and_dispatch́Cext_tskĂяôׂŁC^XNReL
 *  XgECPUbNԁEfBXpb`ԁEif́jݗD
 *  x}XNSԂŌĂяoȂ΂ȂȂD
 */
extern void exit_and_dispatch(void) NoReturn;

/*
 *  J[l̏Ǐďoicore_support.Sj
 *
 *  call_exit_kerneĺCJ[l̏IɌĂяôׂŁC^XN
 *  ReLXgɐ؂芷āCJ[l̏Iiexit_kerneljĂяo
 *  D
 */
extern void call_exit_kernel(void) NoReturn;

     
/*
 *  ^XNReLXg̏
 *
 *  ^XNx~ԂsłԂɈڍs鎞ɌĂ΂D̎_
 *  ŃX^bN̈gĂ͂ȂȂD
 *
 *  activate_contextCCC֐ł͂Ȃ}N`ƂĂ̂́C
 *  ̎_łTCB`ĂȂ߂łD
 */
extern void    start_r(void);

#define activate_context(p_tcb)                                         \
{                                                                       \
    (p_tcb)->tskctxb.sp = (void *)((char_t *)((p_tcb)->p_tinib->stk)    \
                                        + (p_tcb)->p_tinib->stksz);     \
    (p_tcb)->tskctxb.pc = (FP)start_r;                                  \
}

/*
 *  calltex͎gpȂ
 */
#define OMIT_CALLTEX
     
/*
 *  CPUOnh̓o^pe[u
 */
extern const FP exch_tbl[TNUM_EXCH];

/*
 * ^[QbgˑɊ܂܂W̗OǗ@\̏pȂ
 */
#define OMIT_INITIALIZE_EXCEPTION

/*
 * CPUOnh̏
 */
Inline void
initialize_exception(void)
{
}

/*
 *  CPUO̔̃VXeԂ̎Q
 */

/*
 *  CPUO̔̃ReLXg̎Q
 *
 *  CPUO̔̃ReLXgC^XNReLXg̎falseC
 *  łȂtrueԂD
 */
Inline bool_t
exc_sense_context(void *p_excinf)
{
    return((*((uint32_t *) p_excinf)) != 0U);
}

/*
 *  CPUO̔(f)ݗDx}XN̎Q
 */
Inline PRI
exc_get_ipm(void *p_excinf)
{
    return((PRI)(*(((uint32_t *)(p_excinf)) + 1)));
}

/*
 *  CPUO̔CPSR̎擾
 */
Inline uint32_t
exc_get_sr(void *p_excinf){
    return(*(((uint32_t *)(p_excinf)) + 2));    
}

/*
 * CPUbNԂ
 */
Inline bool_t
exc_sense_lock(void *p_excinf){
    return((exc_get_sr(p_excinf) & CPSR_CPULOCK) == CPSR_CPULOCK);
}

/*
 * ݃bNԂ
 */
Inline bool_t
exc_sense_int_lock(void *p_excinf){
    return((exc_get_sr(p_excinf) & CPSR_INTLOCK) == CPSR_INTLOCK);
}

/*
 *  CPUO̔̃ReLXgƊ݂̃}XNԂ̎Q
 *
 *  CPUO̔̃VXeԂCJ[lsłȂC^XNR
 *  eLXgłC݃bNԂłȂCCPUbNԂłȂCi
 *  f́jݗDx}XNSԂł鎞trueCłȂ
 *  falseԂiCPUOJ[lǗO̊ݏŔꍇ
 *  ɂfalseԂjD
 *
 */
Inline bool_t
exc_sense_intmask(void *p_excinf)
{
    return(!exc_sense_context(p_excinf)
             && (exc_get_ipm(p_excinf) == 0U)
               && !exc_sense_lock(p_excinf)
                 && !exc_sense_int_lock(p_excinf));
}

/*
 *  CPUO̔̃ReLXgƊ݁^CPUbNԂ̎Q
 *
 *  CPUO̔̃VXeԂCJ[lsłȂC^XNR
 *  eLXgłC݃bNԂłȂCCPUbNԂłȂ
 *  trueCłȂfalseԂiCPUOJ[lǗO̊ݏ
 *  ŔꍇɂfalseԂjD
 *
 */
Inline bool_t
exc_sense_unlock(void *p_excinf)
{
    return(!exc_sense_context(p_excinf)
             && !exc_sense_lock(p_excinf)
               && !exc_sense_int_lock(p_excinf));
        
}

/*
 *  vZbTˑ̏
 */
extern void core_initialize(void);

/*
 *  vZbTˑ̏I
 */
extern void core_terminate(void);

/*
 *  xN^[e[u̖߂QƂWvAhX
 * istart.Sj
 */
extern void *vector_ref_tbl;

/*
 *  OxN^璼ڎsnho^
 */ 
extern void x_install_exc(EXCNO excno, FP exchdr);

/*
 *  Onh
 */

/*
 *  ` Onhicore_support.Sj
 */
extern void undef_handler(void);

/*
 *  SWI Onhicore_support.Sj
 */
extern void swi_handler(void);

/*
 *  vtFb`A{[h Onhicore_support.Sj
 */
extern void prefetch_handler(void);

/*
 *  f[^A{[h Onhicore_support.Sj
 */
extern void data_abort_handler(void);

/*
 *  FIQ Onhicore_support.Sj
 */
extern void fiq_handler(void);

/*
 *  `̗Oꍇ̏
 */
extern void default_exc_handler(void);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_CORE_CONFIG_H */
