/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2007 - 2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id
 */

/*
 * ^[QbgˑW[imindstormsNXTs̗pj
 */

#include "kernel_impl.h"
#include <sil.h>


/*
 * e݂̊ݗv֎~tȌ
 */
uint32_t idf;

/*
 * ݂̊ݗDx}XN̒l
 */
PRI ipm;
 
/*
 *  ݑݒ肳Ă邩𔻕ʂ邽߂̕ϐ
 */
uint32_t	bitpat_cfgint;

/*
 *  ^[Qbgˑ̏
 */
void
target_initialize(void)
{
    int i;
    
    /*
     *  ARMˑ̏
     */
    core_initialize();

    /*
     * Sݗvrbg̃NA
     */
    sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_ICCR), ~0U);

    /*
     * EOICR(ݏIʒm郌WX^)Zbg
     */
    sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_EOICR), 0U);

	/*
     * fobOp
     * DCR(protect mode)Zbg
     */
	sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_DCR), 1U);
    
    /*
     * ݓ͎Ɋݗv𔻒肷邽SVRɊݔԍZbgD
	 * {͊݃nh̃AhXo^Ƃ낾Cݗv肷邽߂
	 * ݔԍZbgĂD
     */
    for(i = 0; i < TNUM_INT; i++){
        sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_SVR+(i*4)), (uint32_t)i);
    }
    
    /*
     * e݂̊ݗv֎~tOS֎~
     */
    idf = ~0U;

    /*
     * ݗDx}XN0
     */ 
    ipm = 0U;

    /*
     * SĂ݂̊}XN
     */ 
    at91sam7s_disable_int(~0U);

    /*
     *  ݑݒ肳Ă邩𔻕ʂ邽߂̕ϐD
     */
    bitpat_cfgint = 0U;
    
#ifndef VECTOR_KERNEL    
    /*
     *  OxN^e[u֊݃nho^
     */
    x_install_exc(EXCH_NO_IRQ, interrupt_handler);
    x_install_exc(EXCH_NO_UNDEF, undef_handler);
    x_install_exc(EXCH_NO_SWI, swi_handler);
    x_install_exc(EXCH_NO_PABORT, prefetch_handler);
    x_install_exc(EXCH_NO_DABORT, data_abort_handler);
    x_install_exc(EXCH_NO_FIQ, fiq_handler);
#endif /* VECTOR_KERNEL */
     
    /*
     *  target_fput_log \ɂȂ悤UART(BlueTooth)
     */
	//bt_init();
//	sound_init();
}

/*
 *  ^[Qbgˑ̏I
 */
void
target_exit(void)
{
    extern void    software_term_hook(void);
    void (*volatile fp)(void) = software_term_hook;

    /*
     *  software_term_hookւ̃|C^CUvolatileŵfpɑ
     *  Ăĝ́C0Ƃ̔rœKō폜Ȃ悤ɂ邽
     *  ߂łD
     */
    if (fp != 0) {
        (*fp)();
    }

	/*
     *  ARMˑ̏I
     */
    core_terminate();

	/*
     *  ׂĂ݂̊}XND
     */
    at91sam7s_disable_int(~0U);

    /*
     *  Jˑ̏I
     */
    at91sam7s_exit();
	tTerminateNXT_eTerminate_main();
//    nxt_terminate();

}

void
target_fput_log(char_t c)
{
	// Ƃ肠ȂɂȂ: ishikawa-stub
}

/*
 *  ݗvC̑̐ݒ
 *
 *  ASPJ[lł̗pz肵āCp[^G[̓AT[VŃ`Fb
 *  NĂDFI4J[lɗpꍇɂ́CG[Ԃ悤ɂׂ
 *  ł낤D
 *
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
    assert(VALID_INTNO(intno));
    assert(TMIN_INTPRI <= intpri && intpri <= TMAX_INTPRI);

	/*
	 *  ݑݒ肳Ă邩𔻕ʂ邽߂̕ϐ̐ݒ
	 */
	bitpat_cfgint |= INTNO_BITPAT(intno);
    
    /* 
     * 񊄍݂֎~
     */    
    x_disable_int(intno);

    /*
     * xgK/GbWgK̐ݒ
     * IRQ̂݃T|[g
     */
    uint32_t smr_val;

    if((intatr & TA_POSEDGE) != 0U) {
        /*
         * |WeBuGbW
         */
        smr_val = AIC_SRCTYPE_EXT_POSITIVE_EDGE;
    }else if((intatr & TA_HIGHLEVEL) != 0U) {
        /*
         * nCxgK
         */
        smr_val = AIC_SRCTYPE_EXT_HIGH_LEVEL ;
    }else if((intatr & TA_EDGE) != 0U) {
        /*
         * GbWgK
         */
        smr_val = AIC_SRCTYPE_INT_EDGE_TRIGGERED;
    }else{
        /*
         * xgK
         */
        smr_val = AIC_SRCTYPE_INT_LEVEL_SENSITIVE;
    }

	intpri *= -1; /* ݗDx͐̒lŃWX^ɃZbg */

	/* [hWX^ɊݑƗDxZbg */
    sil_wrw_mem((void*)(TADR_AIC_BASE+TOFF_AIC_SMR+intno*4U), smr_val|intpri);
    
    if ((intatr & TA_ENAINT) != 0U){
        (void)x_enable_int(intno);
    }    
}

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 * `݂̊ꍇ̏
 */
void
default_int_handler(void){
    syslog_0(LOG_EMERG, "Unregistered Interrupt occurs.");
    target_exit();
}

#endif /* OMIT_DEFAULT_INT_HANDLER */
