/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: target_support.S 746 2008-02-23 04:46:56Z$
 */

/*
 *  `bvˑW[ AZuꕔiAT91SAM7Spj
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_t^̒萔}N */
#define ULONG_C(val)	(val)		/* ulong_t^̒萔}N */
#include "kernel_impl.h"

/*
 *  ჌x̃^[QbgVXeˑ̏
 *
 *  X^[gAbvW[̒ŁC̑OɌĂяoD          
 */
        .text
        .align 2
        .global hardware_init_hook
hardware_init_hook:
	/*
     * MC_FMR:
	 *   Set up flash memory accessing and memory for 48 MHz FMCN = 50)
	 *   2 wait states (FWS = 1)
	 *   No special flags
	 */
	ldr r0,=0xFFFFFF60
	ldr r1,=((72 << 16) | (1 << 8))
	str r1,[r0]

	/*
	 *    Disable watchdog
	 *    Set MDT_MR disable bit. 
	 *    Note: probably want to set this differently at some stage...
	 */
	ldr r0,=0xFFFFFD44
	ldr r1,=0x00008000
	str r1,[r0]

	/*
	 *    Set up PLL & clock source
	 *    The main crystal is 18.432 MHz
	 *    We want as close as we can get to 48MHz
	 *    We use the PLL to generate 18432000 / 14 * 73 = 96109714
	 *    We then divide this by 2
	 *
	 *  Start main osc
	 */
	ldr r0,=0xFFFFFC20  /* PMC_MOR */
	ldr r1,=0x00000601
	str r1,[r0]

	ldr r0,=0xFFFFFC68  /* PMC_SR */
wait_MOSCS:
	ldr r1,[r0]
	ands r1,r1,#1
	beq wait_MOSCS

	/*
	 * set up PLL
	 */
	ldr r0,=0xFFFFFC2C  /* PMC_PLLR */
	ldr r1,=0x00481C0E
	str r1,[r0]

	ldr r0,=0xFFFFFC68  /* PMC_SR */
wait_pll_lock:
	ldr r1,[r0]
	ands r1,r1,#4
	beq wait_pll_lock

	ldr r0,=0xFFFFFC68  /* PMC_SR */
wait_MCLK_Ready0:
	ldr r1,[r0]
	ands r1,r1,#8
	beq  wait_MCLK_Ready0

	/*
	 * Set up master clock to use clock div 2
	 */
	ldr r0,=0xFFFFFC30 /* PMC_MCKR */
	ldr r1,=0x4
	str r1,[r0]

	ldr r0,=0xFFFFFC68  /* PMC_SR */
wait_MCLK_Ready1:
	ldr r1,[r0]
	ands r1,r1,#8
	beq  wait_MCLK_Ready1

	/*
	 * Set up master clock to use PLL clock div 2
	 */
	ldr r0,=0xFFFFFC30 /* PMC_MCKR */
	ldr r1,=0x7
	str r1,[r0]

	ldr r0,=0xFFFFFC68  /* PMC_SR */
wait_MCLK_Ready2:
	ldr r1,[r0]
	ands r1,r1,#8
	beq  wait_MCLK_Ready2
	
init_done:
/* 	mov     pc, lr*/
	bx	lr


        .text
        .align 2
        .global software_init_hook
software_init_hook:
/*        mov     pc, lr*/
	bx	lr

        .text
        .align 2
        .global software_term_hook
software_term_hook:
/*        mov     pc, lr*/
        bx	lr


/*
 * ݃nh
 *
 * IRQ OxN^Ăяo
 */
    .text
    .align 2
    .global irq_handler
irq_handler:
    /* 
     * IRQ[hŎs
     */
	/* ݔlrIRQ[h̃X^bNɐς */
	sub   lr,lr,#4
	stmfd sp!,{lr}

	/* ݔspsrIRQ[h̃X^bNɐς */
	mrs   lr,spsr
	stmfd sp!,{lr}

	/* ݗvԍ擾AIRQ[h̃X^bNɐς */
    ldr   lr, =TADR_AIC_BASE       
    ldr   lr, [lr, #TOFF_AIC_IVR]
	stmfd sp!, {lr}

	/* ͂ƓȂ <--- protect mode */
	ldr   lr, =TADR_AIC_BASE
	add   lr, lr, #TOFF_AIC_IVR
	str   lr,[lr]
	/**********************************************/

	/* 
     *  ݑÕ[h(X[p[oCU[[h)
     *  ڍsCReLXgۑ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT)
	stmfd sp!, {r0-r3,ip,lr,pc} /* pc̓_~[ */

    /*
     * ݗvԍspsrƖ߂Ԓn擾邽߂IRQ[h
     */
    msr   cpsr, #(CPSR_IRQ|CPSR_IRQ_BIT)
	ldmfd sp!, {r3} /* ݗvԍ */
	ldmfd sp!, {r1} /* spsr */
	ldmfd sp!, {r0} /* ߂Ԓn */

    /*
     *  ݃nhs̃[hiX[p[oCU[[hj
	 *  ߂ԒnspsrX[p[oCU[hp̃X^bNɐς
     */
	msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT)
	str   r0, [sp,#0x18] /* ߂Ԓn */
	stmfd sp!,{r1}       /* spsr */
	mov   lr, sp         /* ̎_̃X^bN𕜋Âߎ擾 */

    /*
     *  d݂
     */
    ldr   r2, =excpt_nest_count /* OE݃lXg񐔂擾 */
    ldr   r1, [r2]
    add   r0, r1, #1            /* OE݃lXg񐔂XV */
    str   r0, [r2]
    cmp   r1, #0    
    bne   irq_handler_1

    /* 
     * iڂ̗Oi݁jȂX^bNύX
     */
    ldr   r0, =_kernel_istkpt
    ldr   sp, [r0]

irq_handler_1:
    stmfd sp!, {lr}     /* Ap̃X^bN|C^̕ۑ */

    /*
     *  ݗv̊ݗDx(f)ݗDx}XNZbg
     *  D܂̍ہCnhsO(f)ݗDx}XN
     *  ۑD
     */
    ldr   r0, =inh_ipm_tbl      /* ݗDx擾 */
    ldr   r1, [r0, r3, lsl #2]  /* r1<-ݗDx   */
    ldr   r0, =ipm              /* ݔO̊ݗDx}XNX^bNɕۑ */
    ldr   r2, [r0]              
    stmfd sp!,{r2}
    str   r1, [r0]              /* (f)ݗDx}XNZbg */

    /*
     * n[hEFA(IRC)݂͊󂯕tC݂ɉėDx}XN
     * ZbgD̂߃\tgEFAIɂ͓ɏ͍sKv͂ȂD
     * \tgEFAI(f)ݗDx}XNグۂɂ́C
     * ݗDx}XNɉĊݗv֎~tOɂ芄݂֎~D
     */
    /*
     *  ݃nh̋NԒn擾
     */
    ldr   r0, =inh_tbl         /* ݃nhe[u̓ǂݏo  */
    ldr   r0, [r0, r3, lsl #2] /* r0<-݃nh            */    
	
    stmfd sp!,{r3}             /* inhno ۑ  */

    /* 
     * 荞݋ 
     */         
    msr   cpsr, #(CPSR_SVC)
	
#ifdef LOG_INH_ENTER
    stmfd sp!,{r0}
    mov   r0, r3         /* inhno p[^    */
    bl    log_inh_enter  /* log_inh_enterĂяo */
    ldmfd sp!,{r0}
#endif /* LOG_INH_ENTER */

    /* 
     * ݃nȟĂяo
     */
    mov   lr, pc
    bx r0

    ldmfd sp!,{r0}       /* inhno 𕜋A  */    
#ifdef LOG_INH_LEAVE
    bl    log_inh_leave  /* log_inh_leaveĂяo */
#endif /* LOG_INH_LEAVE */

    /*
     * J[lǗ݂̊֎~
     */
/*    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT)*/
	mrs	r3, cpsr
	and	r3, r3, #CPSR_FIQ_BIT
	orr	r3, r3, #(CPSR_SVC|CPSR_IRQ_BIT)
	msr	cpsr, r3
	
    /*
     * ݃NA
     */
    ldr   r3, =TADR_AIC_BASE
    mov   r0, #0
    str   r0, [r3, #TOFF_AIC_EOICR]
    
    b     target_ret_int


/*
 * ^[Qbgˑ̗O
 */
    .text
    .global target_exc_handler
target_exc_handler:    
    /*
     *  Os̃[hiX[p[oCU[[hj
     *  ݃bNԁCCPUbNԂCPUO
     *  ԂpD
     */
    msr   cpsr, #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT) 
    str   r0, [sp, #0x18] /* ߂ԒnX^bN */
    stmfd sp!, {r1}       /* spsrX^bNɕۑ */    
    mov   lr, sp          /* ̎_̃X^bN𕜋Âߎ擾 */

    ldr   r0, =ipm        /* ݔO̊ݗDx}XNX^bNɕۑ */
    ldr   r1, [r0]              
    stmfd sp!, {r1}

    /* 
     * ReLXĝ߁Cexcpt_nest_count X^bNɕۑD
     * X^bNɕۑC݂excpt_nest_count-1Ǝ擾ł邪C
     * X^bNɐςłfobOs₷̂ŁCX^bN
     * ۑD
     */
    ldr   r0, =excpt_nest_count
    ldr   r1, [r0]
    stmfd sp!, {r1}

    mov   r3,  sp         /* Ot[Ԓnۑ */

    /*
     *  d荞݂
     */
    ldr   r0, =excpt_nest_count
    ldr   r1, [r0]
    add   r1, r1, #1
    str   r1, [r0]
    cmp   r1, #1
    bne   target_exc_handler_1    

    /* 
     * iڂ̎sȂX^bNύX
     */
    ldr  r0, =_kernel_istkpt
    ldr  sp, [r0]

target_exc_handler_1:    
    stmfd sp!, {lr}     /* Ap̃X^bN|C^̕ۑ */

    /* 
     * ݔO̊ݗDx}XNX^bNɕۑ 
     * ݃nhƏo[`L邽߂ɕۑ
     */
    ldr   r0, =ipm       
    ldr   r1, [r0]              
    stmfd sp!, {r1}

    /*
     *  CPUOnh̋NԒn擾
     */
    ldr   r0, =exch_tbl        /* ݃nhe[u̓ǂݏo */
    ldr   r1, [r0, r2, lsl #2] /* r1<-Onh                 */

    stmfd sp!,{r2}      /* excno ۑ */
    /* 
     * 荞݋ 
     * CPUbNԁC݃bNԂ͌p
     */         
    ldr   r0, [lr]
    and   r0, r0, #(CPSR_IRQ_BIT|CPSR_FIQ_BIT)
    orr   r0, r0, #(CPSR_SVC)
    msr   cpsr, r0

#ifdef LOG_EXC_ENTER
    stmfd sp!,{r1,r3}
    mov   r0, r2         /* excno p[^    */
    bl    log_exc_enter  /* log_exc_enterĂяo */
    ldmfd sp!,{r1,r3}
#endif /* LOG_EXC_ENTER */

    /* 
     * CPUOnȟĂяo
     *
     * Ot[̐擪Ƃēn
     */        
    mov   r0, r3
    mov   lr, pc
/*    mov   pc, r1*/
	bx	r1

    ldmfd sp!,{r0}       /* excno 𕜋A  */    
#ifdef LOG_EXC_LEAVE
    bl    log_exc_leave  /* log_exc_leaveĂяo */
#endif /* LOG_EXC_LEAVE */

/*
 * ^[Qbgˑ̗OȄ݂o
 *
 */

    .global target_ret_exc
target_ret_exc:
    /*
     * J[lǗ݂̊֎~
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT)

    .global target_ret_int
target_ret_int:        
    /*
     * ݗDx}XNɖ߂
     */
    ldmfd sp!, {r1}             /* ̊ݗDx}XN擾 */
    ldr   r0, =ipm              /* ݗDx}XN𕜋A     */
    str   r1, [r0]
    rsb   r1, r1, #0            /* CfbNXƂ邽ߔ]   */              
    ldr   r0, =ipm_mask_tbl     /* (f)̊ݗDx̂邽߂ */
    ldr   r2, [r0, r1, lsl #2]  /* ݗv֎~tO擾 */    
    ldr   r0, =idf              /* e݂̊ݗv֎~tȌԂ擾 */
    ldr   r1, [r0]
    /*
     * e݂̊ݗv֎~tȌԂ(f)̊ݗDx̂
     * ߂̊ݗv֎~tȌԂORƂC̔ے߂邱ƂɂC
     * IRC̊݋WX^ւ̐ݒl𐶐ݒ肷D
     */
    ldr   r0, =TADR_AIC_BASE    /* S݂̊ݗv}XN */
    mvn   lr, #0                
    str   lr, [r0, #TOFF_AIC_IDCR]                                
    orr   r1, r1, r2            /* }XNw肳ĂȂ݂̋ */
    mvn   r1, r1                /* ݒl𐶐 */    
    str   r1, [r0, #TOFF_AIC_IECR]

    /*
     * X^bN|C^̕A
     */
    ldmfd sp!, {r2}             /* ̃X^bN|C^擾 */
    mov   sp, r2
    
    /*
     * ̏ARMˑŎs
     */            
    b     ret_int


/*
 * Zbg
 */
	.global target_stop
target_stop:
	msr cpsr, #(CPSR_IRQ_BIT | CPSR_FIQ_BIT | CPSR_SVC) /* ݋֎~ & X[p[oCU[h */

	/*
	 * PIT̏
	 */
	ldr r0, =TADR_PIT_BASE
	mov r1, #0
	str r1, [r0, #TOFF_PIT_MR]

	/* Zbg */
	b start

#ifdef THUMB_MODE
	.text
	.align 2
	.global current_sr
current_sr:
	mrs	r0, cpsr
	bx	lr
	
	.global set_sr
set_sr:
	msr	cpsr, r0
	bx	lr
	
#endif /* THUMB_MODE */
