/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *  
 *   Copyright (C) 2010 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *  
 *   L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *   Ai{\tgEFAς̂܂ށDȉjgpEE
 *   ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *   (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *       \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *       XR[hɊ܂܂Ă邱ƁD
 *   (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *       pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *       ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *       ̖ۏ؋Kfڂ邱ƁD
 *   (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *       płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *       ƁD
 *     (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *         쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *     (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *         񍐂邱ƁD
 *   (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *       QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *       ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *       RɊÂCL쌠҂TOPPERSvWFNg
 *       Ɛӂ邱ƁD
 *  
 *   {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *   TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *   ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *   A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *   ̐ӔC𕉂ȂD
 *
 */
/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tBluetoothBody_template.c => src/tBluetoothBody.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]# AHA#[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * sendBufferSize   uint32_t         ATTR_sendBufferSize
 * receiveBufferSize uint32_t         ATTR_receiveBufferSize
 * uartBase         void*            ATTR_uartBase   
 * timerBase        void*            ATTR_timerBase  
 * keyCode          char_t*          ATTR_keyCode    
 * status           uint8_t          VAR_status      
 * handle           uint8_t          VAR_handle      
 * waitTimeOut      volatile bool_t  VAR_waitTimeOut 
 * sendBuffer1      char_t*          VAR_sendBuffer1 
 * sendBuffer2      char_t*          VAR_sendBuffer2 
 * sendBufferPointer char_t*          VAR_sendBufferPointer
 * sendBufferCount  uint32_t         VAR_sendBufferCount
 * receiveBuffer1   char_t*          VAR_receiveBuffer1
 * receiveBuffer2   char_t*          VAR_receiveBuffer2
 * receiveBufferPointer char_t*          VAR_receiveBufferPointer
 * receiveBufferCount uint32_t         VAR_receiveBufferCount
 *
 * Ăь֐ #_TCPF_#
 * call port : cAlarm  signature: sAlarm context: task
 *   ER             cAlarm_start( RELTIM alarmTime );
 *   ER             cAlarm_stop( );
 *   ER             cAlarm_refer( T_RALM* pk_alarmStatus );
 * call port : cSemaphore  signature: sSemaphore context: task
 *   ER             cSemaphore_signal( );
 *   ER             cSemaphore_wait( );
 *   ER             cSemaphore_waitPolling( );
 *   ER             cSemaphore_waitTimeout( TMO timeout );
 *   ER             cSemaphore_initialize( );
 *   ER             cSemaphore_refer( T_RSEM* pk_semaphoreStatus );
 *
 * #[</PREAMBLE>]# */

#include "tBluetoothBody_tecsgen.h"
#include <string.h>
#include <kernel.h>

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

#define CHECK_SEND 0
#define CHECK_READ 1

/* Mobt@[e[V */
static void
rot_send_buf()
{
	if(VAR_sendBufferPointer == VAR_sendBuffer1){
		VAR_sendBufferPointer = VAR_sendBuffer2;
	} else {
		VAR_sendBufferPointer = VAR_sendBuffer1;
	}
}

/* Mobt@[e[V */
static void
rot_receive_buf()
{
	// ̃obt@ɂȂĂ͂
	assert(sil_rew_mem((void *)(ATTR_uartBase+TOFF_PDC_RNCR)) == 0);

	// ̃obt@WX^ɃZbg
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNPR), VAR_receiveBufferPointer);
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNCR), ATTR_receiveBufferSize);

	// obt@ւ
	if(VAR_receiveBufferPointer == VAR_receiveBuffer1){
		VAR_receiveBufferPointer = VAR_receiveBuffer2;
	} else {
		VAR_receiveBufferPointer = VAR_receiveBuffer1;
	}
}

/*
 *  Bluetoothgpǂ𒲂ׂ
 */
static bool_t
checkPending(int8_t checkPattern)
{
	uint32_t byteReady;

	switch(checkPattern){
	  case CHECK_READ:
		/*
		 *  R}hMH
		 */
		if(sil_rew_mem((void *)(ATTR_uartBase+TOFF_PDC_RNCR)) == 0){
			byteReady = ATTR_receiveBufferSize * 2 - sil_rew_mem((void *)(ATTR_uartBase+TOFF_PDC_RCR));
		} else {
			byteReady = ATTR_receiveBufferSize - sil_rew_mem((void *)(ATTR_uartBase+TOFF_PDC_RCR));
		}
		
		if(byteReady > VAR_receiveBufferCount){
			return true;
		}
		return false;
		break;
	  case CHECK_SEND:
		/*
		 *  R}hMH
		 */
		if((sil_rew_mem((void *)(ATTR_uartBase+TOFF_PDC_TCR)) != 0) ||
		   (sil_rew_mem((void *)(ATTR_uartBase+TOFF_PDC_TNCR)) != 0)){
			return true;
		}
		return false;
		break;
	  default:
		break;
	}

	return true;
}

/*
 *  ARMRAւ̃R}hM
 *  +--------+---------+------+---+-------------+-------------+
 *  | length | command | DATA |...| checkSUM[H] | checkSUM[L] |
 *  +--------+---------+------+---+-------------+-------------+
 */
static void
sendCommand(uint8_t *command, uint32_t length)
{
	int32_t checkSum = 0;
	int32_t i;

	VAR_sendBufferPointer[0] = (uint8_t)(length + 2);

	for(i = 0; i < length; i++){
		VAR_sendBufferPointer[i + 1] = command[i];
		checkSum += command[i];
	}

	checkSum = -checkSum;
	VAR_sendBufferPointer[length + 2] = (uint8_t)((checkSum >> 8) & 0xff);
	VAR_sendBufferPointer[length + 3] = (uint8_t)(checkSum & 0xff);

	/* DMAM */
	if(sil_rew_mem((void *)(ATTR_uartBase+TOFF_PDC_TNCR)) == 0){
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_TNPR), VAR_sendBufferPointer);
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_TNCR), length + 3);

		rot_send_buf();
	}
}

/* 
 *  ARMRÃR}hM
 *  +--------+---------+------+---+-------------+-------------+
 *  | length | command | DATA |...| checkSUM[H] | checkSUM[L] |
 *  +--------+---------+------+---+-------------+-------------+
 */
static uint32_t
receiveCommand(uint8_t *command, uint32_t length)
{
	int32_t checkSum, negSum, i;
	uint32_t cmd_len, len;
	uint32_t bytes_ready, total_bytes_ready;

	memset(command, 0, length);

	/* 1ڂ̃obt@tɂȂH */
	if(sil_rew_mem((void *)(ATTR_uartBase+TOFF_PDC_RNCR)) == 0){
		bytes_ready = ATTR_receiveBufferSize; // 1obt@͓ǂ߂
		total_bytes_ready = 2 * ATTR_receiveBufferSize - sil_rew_mem((void *)(ATTR_uartBase+TOFF_PDC_RCR)); // 2ڂ̃obt@킹ēǂ߂TCY

	} else { // 1ڂ̃obt@܂tłȂ
		total_bytes_ready = bytes_ready = ATTR_receiveBufferSize - sil_rew_mem((void *)(ATTR_uartBase+TOFF_PDC_RCR)); // ǂ߂̂1obt@ɂ镪
	}
  
	/* 2oCg̃f[^iR}h̃TCYj邩H */
	if(total_bytes_ready > (VAR_receiveBufferCount + 1)){
		// R}h̃TCYi8bitj̓Ǐo
		cmd_len = (uint32_t)VAR_receiveBufferPointer[VAR_receiveBufferCount];

		/*
		 *  R}h̃TCY255byteȉł邽߁C8bit0ɂȂ͂
		 */
		if(VAR_receiveBufferCount < ATTR_receiveBufferSize - 1){
			/*
			 *  obt@ׂȂ̂ŁCPɎ̒lǂ
			 */
			if(VAR_receiveBufferPointer[VAR_receiveBufferCount + 1] == 0){
				cmd_len++;
			}
		} else {
			/*
			 *  obt@ׂ̂ŁC̃obt@̐擪ǂ
			 */
			if(VAR_receiveBufferPointer == VAR_receiveBuffer1){
				if(VAR_receiveBuffer2[0] == 0){
					cmd_len++;
				}
			} else if(VAR_receiveBuffer1[0] == 0){
				cmd_len++;
			}
		}

		/*
         *  R}hŜobt@ɂ΁C
		 *  ̃R}hǂ
		 *  łȂΉCR}hobt@
		 *  ܂ő҂
		 */
		if(bytes_ready >= VAR_receiveBufferCount + cmd_len + 1){
			/*
			 *  R}h1obt@Ɏ܂Ă̂ŁC
			 *  ݂̃obt@R}hǂݏo
			 *  ɁC݂̃obt@|C^炵Ă
			 */
			for(i = 0; i < cmd_len + 1; i++){
				command[i] = VAR_receiveBufferPointer[VAR_receiveBufferCount++];
			}
		} else {
			if(total_bytes_ready >= VAR_receiveBufferCount + cmd_len + 1){
				/*
				 *  R}h2obt@Ɏ܂Ă̂ŁC
				 *  ݂̃obt@Ǝ̃obt@R}hǂݏo
				 *  ɁC݂̃obt@|C^炵Ă
				 */
				for(i = 0; (i < cmd_len + 1) && (VAR_receiveBufferCount < ATTR_receiveBufferSize); i++){
					command[i] = VAR_receiveBufferPointer[VAR_receiveBufferCount++];
				}
				
				VAR_receiveBufferCount = 0U; // obt@|C^Zbg
				rot_receive_buf(); // Mobt@[e[V
				
				for( ; i < cmd_len + 1; i++){
					command[i] = VAR_receiveBufferPointer[VAR_receiveBufferCount++];
				}
			} else {
				return; // R}hobt@ɓ܂ő҂
			}
		}
	}

	/*
	 *  `FbNŤ
	 */
	len = command[0];
	
	if(len == 0){
		return 0;
	}
	
	checkSum = len;
	
	if(len - 1 <= length){
		for(i = 1; i < len - 1; i++){
			checkSum += (command[i] & 0xff);
		}
		
		negSum = (command[len - 1] & 0xff) << 8;
		negSum += (command[len] & 0xff);
		if(checkSum + negSum == 65536){
			 return len - 1;
		} else {
			return 0;
		}
	}
	
	return 0;	
}

/*
 *  bluetoothfoCX̃Zbg
 */
Inline void
bluetoothReset()
{
	uint8_t *buf = VAR_sendBuffer1;

	// Perform hardware reset. This function has some relatively long
	// delays in it and so should probably only be called during application
	// initialisation and termination. Calling it at other times may cause
	// problems for other real time tasks.

	// If power is currently off to the BC4 do not reset it!
	if((sil_rew_mem((void *)(TADR_PIO_BASE+TOFF_PIO_ODSR)) & BT_RST_PIN) == 0){
		return;
	}

	// Ask for command mode
	sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_CODR), BT_ARM7_CMD_PIN);
	// BC4 reset sequence. First take the reset line low for 100ms
	sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_CODR), BT_RST_PIN);
	// Wait and discard any packets that may be around
	/*
	 *  100ms҂
	 */
	VAR_waitTimeOut = true;
	/*
	 * 	ŃfBXpb`Ă܂ƁCR}hMłȂ\
	 */
	dis_dsp(); // fBXpb`֎~
	cAlarm_start(100);
	while(VAR_waitTimeOut){
		receiveCommand(buf, ATTR_receiveBufferSize);
	}
	ena_dsp(); // fBXpb`
	VAR_waitTimeOut = true;

	sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_SODR), BT_RST_PIN);
	// Now wait either for 5000ms or for the BC4 chip to signal reset
	// complete. Note we use the out buffer as a scratch area here
	// this id safe since we are forcing a reset.
	/*
	 *  5000ms҂
	 */
	VAR_waitTimeOut = true;
	/*
	 * 	ŃfBXpb`Ă܂ƁCR}hMłȂ\
	 */
	dis_dsp(); // fBXpb`֎~
	cAlarm_start(5000);
	while(VAR_waitTimeOut){
		receiveCommand(buf, ATTR_receiveBufferSize);
		// Look for the reset indication and the checksum
		if((buf[0] == 3) && (buf[1] == MSG_RESET_INDICATION) && 
		   (buf[2] == 0xff) && (buf[3] == 0xe9)){
			break;
		}
	}
	ena_dsp(); // fBXpb`
	VAR_waitTimeOut = true;
	// Force command mode
	sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_CODR), BT_ARM7_CMD_PIN);
}

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBluetooth
 * entry port: eBluetooth
 * signature:  sBluetooth
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBluetooth_open
 * name:         eBluetooth_open
 * global_name:  tBluetoothBody_eBluetooth_open
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBluetooth_open()
{
	/* Mobt@DMAɐݒ */
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RPR), VAR_receiveBuffer1);
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RCR), ATTR_receiveBufferSize);
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNPR), VAR_receiveBuffer2);
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNCR), ATTR_receiveBufferSize);

	/* M */
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_CR), (US_RXEN | US_TXEN));
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_PTCR), (PDC_RXTEN | PDC_TXTEN));
}

/* #[<ENTRY_FUNC>]# eBluetooth_getLocalAddress
 * name:         eBluetooth_getLocalAddress
 * global_name:  tBluetoothBody_eBluetooth_getLocalAddress
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
bool_t
eBluetooth_getLocalAddress(uint8_t* address)
{
	uint8_t command[1];
	uint8_t reply[32];
	int32_t i;
	
	/*
     * [JAhX𓾂邽߂ɃR}h𑗐M
	 */
	command[0] = MSG_GET_LOCAL_ADDR;
	sendCommand(command, 1);

	/*
     * ʂԂĂ܂ŁC3bԃ|[Oő҂
	 */
	VAR_waitTimeOut = true;
	/*
	 * 	ŃfBXpb`Ă܂ƁCR}hMłȂ\
	 */
	dis_dsp(); // fBXpb`֎~
	cAlarm_start(3000);
	while(VAR_waitTimeOut){
		receiveCommand(reply,32);

		if(reply[0] != 0 && reply[1] == MSG_GET_LOCAL_ADDR_RESULT){
			for(i = 0; i < 7; i++){
				address[i] = reply[i + 2];
			}

			return true;
		}
		
	}
	ena_dsp(); // fBXpb`
	VAR_waitTimeOut = true;

	return false;	
}

/* #[<ENTRY_FUNC>]# eBluetooth_getDeviceName
 * name:         eBluetooth_getDeviceName
 * global_name:  tBluetoothBody_eBluetooth_getDeviceName
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
bool_t
eBluetooth_getDeviceName(uint8_t* name)
{
	uint8_t command[1];
	uint8_t reply[32];
	int32_t i;

	/*
	 * 	foCX𓾂邽߂ɃR}h𑗐M
	 */
	command[0] = MSG_GET_FRIENDLY_NAME;
	sendCommand(command, 1);

	/*
	 *  ʂԂĂ܂ŁC3bԃ|[Oő҂
	 */
	VAR_waitTimeOut = true;
	/*
	 * 	ŃfBXpb`Ă܂ƁCR}hMłȂ\
	 */
	dis_dsp(); // fBXpb`֎~
	cAlarm_start(3000);
	while(VAR_waitTimeOut){
		receiveCommand(reply,32);

		if(reply[0] != 0 && reply[1] == MSG_GET_FRIENDLY_NAME_RESULT){
			for(i = 0; i < 16; i++){
				name[i] = reply[i + 2];
				if(name[i] == '\0'){
					return true; /* shorter than 16 characters because null terminated */
				}
			}
			
			if(i == 16){
				/* Add null terminator to easy to handle the name as a string */
				reply[16] = '\0';
			}
			return true;
		}
	}
	ena_dsp(); // fBXpb`
	VAR_waitTimeOut = true;
	
	return false;
}

/* #[<ENTRY_FUNC>]# eBluetooth_setDeviceName
 * name:         eBluetooth_setDeviceName
 * global_name:  tBluetoothBody_eBluetooth_setDeviceName
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
bool_t
eBluetooth_setDeviceName(const uint8_t* name)
{
	uint8_t command[17];
	
	if((VAR_status != BT_CONNECTED) && (VAR_status != BT_STREAM)){
		command[0] = MSG_SET_FRIENDLY_NAME;

		strncpy((char_t *)&command[1], (const char_t *)name, 16);
		sendCommand(command, 17);
		/*
		 *  100ms҂
		 */
		VAR_waitTimeOut = true;
		cAlarm_start(100);
		while(VAR_waitTimeOut);
		VAR_waitTimeOut = true;

		return true;
	}

	return false;
}

/* #[<ENTRY_FUNC>]# eBluetooth_setFactorySetting
 * name:         eBluetooth_setFactorySetting
 * global_name:  tBluetoothBody_eBluetooth_setFactorySetting
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
bool_t
eBluetooth_setFactorySetting()
{
	uint8_t command[1];
	
	if((VAR_status != BT_CONNECTED) && (VAR_status != BT_STREAM)){
		command[0] = MSG_SET_FACTORY_SETTINGS;
		sendCommand(command, 1);
		/*
		 *  100ms҂
		 */
		VAR_waitTimeOut = true;
		cAlarm_start(100);
		while(VAR_waitTimeOut);
		VAR_waitTimeOut = true;

		return true;
	}

	return false;
}

/* #[<ENTRY_FUNC>]# eBluetooth_getStatus
 * name:         eBluetooth_getStatus
 * global_name:  tBluetoothBody_eBluetooth_getStatus
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
uint8_t
eBluetooth_getStatus()
{
	return VAR_status;
}

/* #[<ENTRY_FUNC>]# eBluetooth_initializeMaster
 * name:         eBluetooth_initializeMaster
 * global_name:  tBluetoothBody_eBluetooth_initializeMaster
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
int32_t
eBluetooth_initializeMaster(const uint8_t* address)
{
	int32_t i;
	uint8_t command[32];
	uint8_t reply[32];
	uint8_t dummy[32];
	uint8_t device[7];

	if(VAR_status == BT_NO_INIT){
		/* reset BC4 chip */
		bluetoothReset();
		VAR_status = BT_INITIALIZED;
		
		command[0] = MSG_CONNECT;
		for(i = 0; i < 7; i++){
			command[i + 1] = address[i];
		}
		
		sendCommand(command, 8);

		/*
		 *  100ms҂
		 */
		VAR_waitTimeOut = true;
		cAlarm_start(100);
		while(VAR_waitTimeOut);
		VAR_waitTimeOut = true;
	} else if(VAR_status == BT_INITIALIZED){
		/* search for the slave device
	 	 * (based on LEJOS Bluetooth.connection)
   	 	 */
		receiveCommand(reply,32);
		
		if(reply[0] != 0){
			switch(reply[1]){
			  case MSG_REQUEST_PIN_CODE:
				/* get bd_addr from slave */
				for(i = 0; i < 7; i++){
					device[i] = reply[i + 2];
				}

				memset(command, 0, sizeof(command));
				command[0] = MSG_PIN_CODE;
				/* fill in slave bd_addr */
				for(i = 0; i < 7; i++){
					command[i + 1] = device[i];
				}
				/* fill in pin code */
				for(i = 0; (i < 16) && (ATTR_keyCode[i] != '\0'); i++){
					command[i + 8] = (uint8_t)ATTR_keyCode[i];
				}
				
				sendCommand(command, 24);
				break;
				
			  case MSG_CONNECT_RESULT:
				/*
				 *  300ms҂
				 */
				VAR_waitTimeOut = true;
				cAlarm_start(300);
				while(VAR_waitTimeOut);
				VAR_waitTimeOut = true;

				receiveCommand(dummy,32);

				if(dummy[0] == 0){
					VAR_handle = reply[3];
					VAR_status = BT_CONNECTED;
				}
				break;

			  default:
				break;
			}
		}
	}
	
	if(VAR_status == BT_CONNECTED){
		command[0] = MSG_OPEN_STREAM;
		command[1] = VAR_handle;
		sendCommand(command, 2);

		/*
		 *  100ms҂
		 */
		VAR_waitTimeOut = true;
		cAlarm_start(100);
		while(VAR_waitTimeOut);
		VAR_waitTimeOut = true;
		
		/* set stream mode */
		sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_SODR), BT_ARM7_CMD_PIN);
		VAR_status = BT_STREAM;
	}
	
	return VAR_status;
}

/* #[<ENTRY_FUNC>]# eBluetooth_initializeSlave
 * name:         eBluetooth_initializeSlave
 * global_name:  tBluetoothBody_eBluetooth_initializeSlave
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
int32_t
eBluetooth_initializeSlave()
{
	int32_t i;
	uint8_t command[32];
	uint8_t reply[32];
	uint8_t dummy[32];
	uint8_t address[7];
	
	if(VAR_status == BT_NO_INIT){
		/* reset BC4 chip */
		bluetoothReset();
		VAR_status = BT_INITIALIZED;

	} else if(VAR_status == BT_INITIALIZED){
		/*
		 *  Ń}X^̐ڑv`FbN
		 */
		receiveCommand(reply, 32);

		if(reply[0] != 0){
			switch(reply[1]){			
			  case MSG_REQUEST_PIN_CODE:
				for(i = 0; i < 7; i++){
					address[i] = reply[i + 2];
				}
				
				memset(command, 0, sizeof(command));
				command[0] = MSG_PIN_CODE;
				/* fill in slave bd_addr */
				for(i = 0; i < 7; i++){
					command[i + 1] = address[i];
				}
				/* fill in pin code */
				for(i = 0; (i < 16) && (ATTR_keyCode[i] != '\0'); i++){
					command[i + 8] = (uint8_t)ATTR_keyCode[i];
				}
				
				sendCommand(command, 24);
				break;
				
			  case MSG_REQUEST_CONNECTION:
				for(i = 0; i < 7; i++){
					address[i] = reply[i + 2];
				}
				
				command[0] = MSG_ACCEPT_CONNECTION;
				command[1] = 1;
				sendCommand(command, 2);
				break;
				
			  case MSG_CONNECT_RESULT:
				/*
				 *  300ms҂
				 */
				VAR_waitTimeOut = true;
				cAlarm_start(300);
				while(VAR_waitTimeOut);
				VAR_waitTimeOut = true;
				
				receiveCommand(dummy,32);

				if(dummy[0] == 0){
					VAR_handle = reply[3];
					VAR_status = BT_CONNECTED;
				}
				break;
				
			  default:
				break;
			}
		}
	}

	if(VAR_status == BT_CONNECTED){
		command[0] = MSG_OPEN_STREAM;
		command[1] = VAR_handle;
		sendCommand(command, 2);

		/*
		 *  100ms҂
		 */
		VAR_waitTimeOut = true;
		cAlarm_start(100);
		while(VAR_waitTimeOut);
		VAR_waitTimeOut = true;

		/* set stream mode */
		sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_SODR), BT_ARM7_CMD_PIN);
		VAR_status = BT_STREAM;
		cSemaphore_signal();
	}
	
	return VAR_status;
}

/* #[<ENTRY_FUNC>]# eBluetooth_terminateConnection
 * name:         eBluetooth_terminateConnection
 * global_name:  tBluetoothBody_eBluetooth_terminateConnection
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBluetooth_terminateConnection()
{
	uint8_t command[2];
	
	if((VAR_status == BT_CONNECTED) || VAR_status == (BT_STREAM)){
		sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_CODR), BT_ARM7_CMD_PIN);

		/*
		 *  100ms҂
		 */
		VAR_waitTimeOut = true;
		cAlarm_start(100);
		while(VAR_waitTimeOut);
		VAR_waitTimeOut = true;

		command[0] = MSG_CLOSE_CONNECTION;
		command[1] = VAR_handle;

		sendCommand(command, 2);

		/*
		 *  100ms҂
		 */
		VAR_waitTimeOut = true;
		cAlarm_start(100);
		while(VAR_waitTimeOut);
		VAR_waitTimeOut = true;
	}

	VAR_status = BT_NO_INIT;
}

/* #[<ENTRY_FUNC>]# eBluetooth_sendPacket
 * name:         eBluetooth_sendPacket
 * global_name:  tBluetoothBody_eBluetooth_sendPacket
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
uint32_t
eBluetooth_sendPacket(const uint8_t* buffer, uint32_t length)
{
	int32_t i;

	if(VAR_status == BT_STREAM && length <= ATTR_sendBufferSize){
		/*
		 *  f[^TCY𑗐Mobt@Ɋi[
		 */
		VAR_sendBufferPointer[0] = (uint8_t)(length & 0xFF); // 8bit
		VAR_sendBufferPointer[1] = (uint8_t)((length >> 8) & 0xFF); // 8bit
		
		/*
		 *  f[^𑗐Mobt@Ɋi[
		 */
		for(i = 0; i < length; i++){
			VAR_sendBufferPointer[i + 2] = buffer[i];
		}

		/*
		 *  f[^MłȂƂ`FbN
		 */
		if(checkPending(CHECK_SEND)){
			return 0;
		}

		/*
		 *  f[^𑗐MCMTCYԂ
		 */
		sendCommand(VAR_sendBufferPointer, length + 2);
		return length;
	}
	
	return 0;
}

/* #[<ENTRY_FUNC>]# eBluetooth_readPacket
 * name:         eBluetooth_readPacket
 * global_name:  tBluetoothBody_eBluetooth_readPacket
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
uint32_t
eBluetooth_readPacket(uint8_t* buffer, uint32_t length)
{
	int32_t i;
	uint8_t tmp[ATTR_receiveBufferSize];
	uint32_t receiveLength;

	if(VAR_status == BT_STREAM && length <= ATTR_receiveBufferSize){
		/*
		 *  f[^M
		 */
		receiveCommand(tmp, ATTR_receiveBufferSize);

		/*
		 *  Mf[^TCY擾
		 */
		receiveLength = tmp[0];
		
		/*
		 *  Mf[^obt@Ɋi[
		 */
		if(receiveLength > 0 && receiveLength <= length + 2){
			for(i = 0; (i < receiveLength) && (i < length); i++){
				buffer[i] = tmp[i + 2];
			}

			return receiveLength - 2;
		}

		return 0;
	}

	return 0;
}

/* #[<ENTRY_PORT>]# eInitialize
 * entry port: eInitialize
 * signature:  sInitializeRoutineBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eInitialize_main
 * name:         eInitialize_main
 * global_name:  tBluetoothBody_eInitialize_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eInitialize_main()
{
	uint32_t dummy;
	
	/*
	 *  ϐ̏
	 */
	VAR_status = BT_NO_INIT;
	VAR_sendBufferPointer = VAR_sendBuffer1;
	VAR_sendBufferCount = 0;
	VAR_receiveBufferPointer = VAR_receiveBuffer1;
	VAR_receiveBufferCount = 0;
	
	/*
	 *  foCXWX^̏
	 */
	sil_wrw_mem((void *)(TADR_PMC_BASE+TOFF_PMC_PCER), (1 << INTNO_US1_PID));

	/* parallel I/O Controller */
	sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PDR), (BT_RX_PIN | BT_TX_PIN | BT_SCK_PIN | BT_RTS_PIN | BT_CTS_PIN));
	sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_ASR), (BT_RX_PIN | BT_TX_PIN | BT_SCK_PIN | BT_RTS_PIN | BT_CTS_PIN));
	sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PER), (BT_CS_PIN | BT_RST_PIN));
	sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_OER), (BT_CS_PIN | BT_RST_PIN));
	sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_SODR), (BT_CS_PIN | BT_RST_PIN));
	sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PUDR), BT_ARM7_CMD_PIN);
	sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PER), BT_ARM7_CMD_PIN);
	sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_CODR), BT_ARM7_CMD_PIN);
	sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_OER), BT_ARM7_CMD_PIN);
	
	// Configure timer 01 as trigger for ADC, sample every 0.5ms
	sil_wrw_mem((void *)(TADR_PMC_BASE+TOFF_PMC_PCER), (1 << INTNO_TC1_PID));
	sil_wrw_mem((void *)(ATTR_timerBase+TOFF_TC_CCR), TC_CLKDIS);
	sil_wrw_mem((void *)(ATTR_timerBase+TOFF_TC_IDR), (~0));

	dummy = sil_rew_mem((void *)(ATTR_timerBase+TOFF_TC_SR));

	sil_wrw_mem((void *)(ATTR_timerBase+TOFF_TC_CMR), (TC_WAVE | TC_WAVESEL10 | TC_ACPA_SET | TC_ACPC_CLEAR | TC_ASWTRG_SET)); /* MCLK/2, wave mode 10 */
	sil_wrw_mem((void *)(ATTR_timerBase+TOFF_TC_RC), ((CLOCK_FREQUENCY/2)/(2000)));
	sil_wrw_mem((void *)(ATTR_timerBase+TOFF_TC_RA), ((CLOCK_FREQUENCY/2)/(4000)));
	sil_wrw_mem((void *)(ATTR_timerBase+TOFF_TC_CCR), TC_CLKEN);
	sil_wrw_mem((void *)(ATTR_timerBase+TOFF_TC_CCR), TC_SWTRG);

	/* A/D Converter */
	sil_wrw_mem((void *)(TADR_PMC_BASE+TOFF_PMC_PCER), (1 << INTNO_ADC_PID));
	sil_wrw_mem((void *)(TADR_ADC_BASE+TOFF_ADC_MR), 0);
	sil_wrw_mem((void *)(TADR_ADC_BASE+TOFF_ADC_MR), (ADC_TRGEN_EN | ADC_TRGSEL_TIOA1 | 0x00003F00 | 0x00020000 | 0x09000000));

	sil_wrw_mem((void *)(TADR_ADC_BASE+TOFF_ADC_CHER), (ADC_CH6 | ADC_CH4));
}

/* #[<ENTRY_PORT>]# eTerminate
 * entry port: eTerminate
 * signature:  sTerminateRoutineBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eTerminate_main
 * name:         eTerminate_main
 * global_name:  tBluetoothBody_eTerminate_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eTerminate_main()
{
}

/* #[<ENTRY_PORT>]# eiAlarmBody
 * entry port: eiAlarmBody
 * signature:  siHandlerBody
 * context:    non-task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eiAlarmBody_main
 * name:         eiAlarmBody_main
 * global_name:  tBluetoothBody_eiAlarmBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eiAlarmBody_main()
{
	VAR_waitTimeOut = false;
}

/* #[<POSTAMBLE>]#
 *   AEA導g[CWSCC
 * #[</POSTAMBLE>]#*/
