/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * ƤӸؿ #_TCPF_#
 * call port : cCall  signature: sSample context: task
 *   ER             cCall_sayHello( int32_t times );
 *   ER             cCall_howAreYou( char_t* buf, int32_t len );
 *   ER             cCall_giftToYou( char_t* buf, int32_t len );
 *   ER             cCall_returnGiftFromYou( int16_t** buf, int32_t* len );
 *   ER             cCall_transferStruct( const struct stA * a, int32_t len );
 *   ER             cCall_transferStruct2( struct stA  a );
 *   ER             cCall_onewayFunc( char_t* buf, int32_t len );
 *   void           cCall_exit( );
 * require port : signature: sKernel context: task
 *   ER             exitTask( );
 *   ER             getTime( SYSTIM* p_system_time );
 *   ER             getMicroTime( SYSUTM* p_system_micro_time );
 *   ER             exitKernel( );
 * allocator port for call port: cCall func: giftToYou param: buf
 *   ER             cCall_giftToYou_buf_alloc( int32_t size, void** p );
 *   ER             cCall_giftToYou_buf_dealloc( const void* ptr );
 * allocator port for call port: cCall func: returnGiftFromYou param: buf
 *   ER             cCall_returnGiftFromYou_buf_alloc( int32_t size, void** p );
 *   ER             cCall_returnGiftFromYou_buf_dealloc( const void* ptr );
 * allocator port for call port: cCall func: onewayFunc param: buf
 *   ER             cCall_onewayFunc_buf_alloc( int32_t size, void** p );
 *   ER             cCall_onewayFunc_buf_dealloc( const void* ptr );
 *
 * #[</PREAMBLE>]# */

#include "tSimple_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* ｪλ */
#define	E_ID	(-18)	/* IDֹ */
#endif

/* #[<ENTRY_PORT>]# eBody
 * entry port: eBody
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBody_main
 * name:         eBody_main
 * global_name:  tSimple_eBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBody_main()
{
	char     buf[256];
	char_t   *allocbuf;
	int16_t  *allocbuf2;
	int32_t  i, len;

#define N_HELLO 3
	printf( "Simple: Say hello %d times.\n", N_HELLO );
	cCall_sayHello( N_HELLO );            /* ƤӸ cCall  sayHello ƤӽФ */

	printf( "Simple: How are you?\n" );
	printf( "tSimple: buf addr: %08x, size: %d\n", buf, sizeof buf );
	cCall_howAreYou( buf, sizeof buf );   /* ƤӸ cCall  howAreYou ƤӽФ */
	printf( "returned\n" );
	puts( buf );

#define GIFT_LEN   256
	cCall_giftToYou_buf_alloc( GIFT_LEN, (void **)&allocbuf );
	strcpy( allocbuf, "Good Luck!!" );
	cCall_giftToYou( allocbuf, GIFT_LEN );

	cCall_returnGiftFromYou( &allocbuf2, &len );
	printf( "return gift len: %d\n", len );
	for( i = 0; i < len; i++ ){
		printf( "%04x ", allocbuf2[i] );
		if( i % 8 == 7 )
			putchar( '\n' );
	}
	cCall_returnGiftFromYou_buf_dealloc( (void *)allocbuf2 );

	{
		struct stA a[4];
		int  i;
		
		for( i = 0; i < 4; i++ ){
			a[i].a = i+1;
			a[i].b = (i+1)*(i+1);
		}
		cCall_transferStruct( a, 4 );
	}

	{
#define LEN_BUF 1024
#define LEN_INT (LEN_BUF / sizeof( int32_t ))

		void *p;
		int  i;

		printf( "oneway func\n" );
		cCall_onewayFunc_buf_alloc( LEN_BUF, &p );

		for( i = 0; i < LEN_INT; i++ ){
			((int32_t *)p)[i] = i;
		}

		cCall_onewayFunc( p, 1024 );
	}

	cCall_exit();

#define SLEEP (1)
	printf("sleeping %d second\n", SLEEP );
	sleep( SLEEP );
	printf("exiting\n" );

	exitKernel();
}

/* #[<ENTRY_PORT>]# eSimple
 * entry port: eSimple
 * signature:  sSimple
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eSimple_onewayPtr
 * name:         eSimple_onewayPtr
 * global_name:  tSimple_eSimple_onewayPtr
 * oneway:       true
 * #[</ENTRY_FUNC>]# */
ER
eSimple_onewayPtr(const uint32_t* in)
{
	printf( "eSimple_onewayPtr: *in=%d\n", *in );
}

/* #[<ENTRY_FUNC>]# eSimple_onewayArray
 * name:         eSimple_onewayArray
 * global_name:  tSimple_eSimple_onewayArray
 * oneway:       true
 * #[</ENTRY_FUNC>]# */
ER
eSimple_onewayArray(const uint32_t* in, int32_t len)
{
	int   i;
	printf( "eSimple_onewayArray: len=%d\n", len );
	for( i = 0; i < len; i++ ){
		printf( "%08x ", in[i] );
		if( i % 8 == 7 )
			putchar( '\n' );
	}
}

/* #[<ENTRY_FUNC>]# eSimple_onewayDoubleArray
 * name:         eSimple_onewayDoubleArray
 * global_name:  tSimple_eSimple_onewayDoubleArray
 * oneway:       true
 * #[</ENTRY_FUNC>]# */
ER
eSimple_onewayDoubleArray(const int32_t* in, int32_t len, const int32_t* in2, int32_t len2)
{
	int   i;
	printf( "eSimple_onewayDoubleArray: len=%d, len2=%d\n", len, len2 );
	printf( "eSimple_onewayDoubleArray: in1:\n" );

	for( i = 0; i < len; i++ ){
		printf( "%08x ", in[i] );
		if( i % 8 == 7 )
			putchar( '\n' );
	}
	printf( "eSimple_onewayDoubleArray: in2:\n" );
	for( i = 0; i < len2; i++ ){
		printf( "%08x ", in2[i] );
		if( i % 8 == 7 )
			putchar( '\n' );
	}
}

/* #[<ENTRY_FUNC>]# eSimple_onewayString
 * name:         eSimple_onewayString
 * global_name:  tSimple_eSimple_onewayString
 * oneway:       true
 * #[</ENTRY_FUNC>]# */
ER
eSimple_onewayString(const char_t* in, int32_t len)
{
	printf( "eSimple_onewayString: len=%d\n", len );
	puts( in );
}

/* #[<ENTRY_FUNC>]# eSimple_onewayStruct
 * name:         eSimple_onewayStruct
 * global_name:  tSimple_eSimple_onewayStruct
 * oneway:       true
 * #[</ENTRY_FUNC>]# */
ER
eSimple_onewayStruct(const struct stA * a)
{
	printf( "eSimple_onewayStruct:\n" );
	printf( " a->a=%d, a->b=%d\n", a->a, a->b );
}

/* #[<ENTRY_FUNC>]# eSimple_onewayStruct2
 * name:         eSimple_onewayStruct2
 * global_name:  tSimple_eSimple_onewayStruct2
 * oneway:       true
 * #[</ENTRY_FUNC>]# */
ER
eSimple_onewayStruct2(const struct stA * a, int32_t len)
{
	int  i;

	printf( "eSimple_onewayStruct2: len=%d\n", len );
	for( i = 0; i < len; i++ )
		printf( " a[%d].a=%d, a[%d].b=%d\n", i, a[i].a, i, a[i].b );
}

/* #[<ENTRY_FUNC>]# eSimple_exit
 * name:         eSimple_exit
 * global_name:  tSimple_eSimple_exit
 * oneway:       true
 * #[</ENTRY_FUNC>]# */
void
eSimple_exit()
{
	pthread_exit(0);
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
